t3904-stash-patch: fix test description
[git.git] / t / test-lib.sh
blobc09677802cce067a946a2550cdd2d8ef33434e81
1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
19 ORIGINAL_TERM=$TERM
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
24 then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29 else
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
34 if test -z "$TEST_OUTPUT_DIRECTORY"
35 then
36 # Similarly, override this to store the test-results subdir
37 # elsewhere
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
40 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
42 ################################################################
43 # It appears that people try to run tests without building...
44 "$GIT_BUILD_DIR/git" >/dev/null
45 if test $? != 1
46 then
47 echo >&2 'error: you do not seem to have built git yet.'
48 exit 1
51 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52 export PERL_PATH SHELL_PATH
54 # if --tee was passed, write the output not only to the terminal, but
55 # additionally to the file test-results/$BASENAME.out, too.
56 case "$GIT_TEST_TEE_STARTED, $* " in
57 done,*)
58 # do not redirect again
60 *' --tee '*|*' --va'*)
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
66 exit
68 esac
70 # For repeatability, reset the environment to known value.
71 LANG=C
72 LC_ALL=C
73 PAGER=cat
74 TZ=UTC
75 TERM=dumb
76 export LANG LC_ALL PAGER TERM TZ
77 EDITOR=:
78 # A call to "unset" with no arguments causes at least Solaris 10
79 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80 # deriving from the command substitution clustered with the other
81 # ones.
82 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
83 my @env = keys %ENV;
84 my $ok = join("|", qw(
85 TRACE
86 DEBUG
87 USE_LOOKUP
88 TEST
89 .*_TEST
90 PROVE
91 VALGRIND
92 UNZIP
93 PERF_
94 CURL_VERBOSE
95 ));
96 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
97 print join("\n", @vars);
99 unset XDG_CONFIG_HOME
100 unset GITPERLLIB
101 GIT_AUTHOR_EMAIL=author@example.com
102 GIT_AUTHOR_NAME='A U Thor'
103 GIT_COMMITTER_EMAIL=committer@example.com
104 GIT_COMMITTER_NAME='C O Mitter'
105 GIT_MERGE_VERBOSITY=5
106 GIT_MERGE_AUTOEDIT=no
107 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
108 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
110 export EDITOR
112 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
113 GIT_TRACE_BARE=1
114 export GIT_TRACE_BARE
116 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
117 then
118 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
119 export GIT_INDEX_VERSION
122 # Add libc MALLOC and MALLOC_PERTURB test
123 # only if we are not executing the test with valgrind
124 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
125 test -n "$TEST_NO_MALLOC_CHECK"
126 then
127 setup_malloc_check () {
128 : nothing
130 teardown_malloc_check () {
131 : nothing
133 else
134 setup_malloc_check () {
135 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
136 export MALLOC_CHECK_ MALLOC_PERTURB_
138 teardown_malloc_check () {
139 unset MALLOC_CHECK_ MALLOC_PERTURB_
143 : ${ASAN_OPTIONS=detect_leaks=0}
144 export ASAN_OPTIONS
146 # Protect ourselves from common misconfiguration to export
147 # CDPATH into the environment
148 unset CDPATH
150 unset GREP_OPTIONS
151 unset UNZIP
153 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
154 1|2|true)
155 echo "* warning: Some tests will not work if GIT_TRACE" \
156 "is set as to trace on STDERR ! *"
157 echo "* warning: Please set GIT_TRACE to something" \
158 "other than 1, 2 or true ! *"
160 esac
162 # Convenience
164 # A regexp to match 5 and 40 hexdigits
165 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
166 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
168 # Zero SHA-1
169 _z40=0000000000000000000000000000000000000000
171 # Line feed
172 LF='
175 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
176 # when case-folding filenames
177 u200c=$(printf '\342\200\214')
179 export _x05 _x40 _z40 LF u200c
181 # Each test should start with something like this, after copyright notices:
183 # test_description='Description of this test...
184 # This test checks if command xyzzy does the right thing...
186 # . ./test-lib.sh
188 unset color
189 while test "$#" -ne 0
191 case "$1" in
192 -d|--d|--de|--deb|--debu|--debug)
193 debug=t; shift ;;
194 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
195 immediate=t; shift ;;
196 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
197 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
199 shift; test "$#" -ne 0 || {
200 echo 'error: -r requires an argument' >&2;
201 exit 1;
203 run_list=$1; shift ;;
204 --run=*)
205 run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
206 -h|--h|--he|--hel|--help)
207 help=t; shift ;;
208 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
209 verbose=t; shift ;;
210 --verbose-only=*)
211 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
212 shift ;;
213 -q|--q|--qu|--qui|--quie|--quiet)
214 # Ignore --quiet under a TAP::Harness. Saying how many tests
215 # passed without the ok/not ok details is always an error.
216 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
217 --with-dashes)
218 with_dashes=t; shift ;;
219 --no-color)
220 color=; shift ;;
221 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
222 valgrind=memcheck
223 shift ;;
224 --valgrind=*)
225 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
226 shift ;;
227 --valgrind-only=*)
228 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
229 shift ;;
230 --tee)
231 shift ;; # was handled already
232 --root=*)
233 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
234 shift ;;
236 trace=t
237 verbose=t
238 shift ;;
240 echo "error: unknown test option '$1'" >&2; exit 1 ;;
241 esac
242 done
244 if test -n "$valgrind_only"
245 then
246 test -z "$valgrind" && valgrind=memcheck
247 test -z "$verbose" && verbose_only="$valgrind_only"
248 elif test -n "$valgrind"
249 then
250 verbose=t
253 error () {
254 say_color error "error: $*"
255 GIT_EXIT_OK=t
256 exit 1
259 say () {
260 say_color info "$*"
263 test "${test_description}" != "" ||
264 error "Test script did not set test_description."
266 if test "$help" = "t"
267 then
268 printf '%s\n' "$test_description"
269 exit 0
272 exec 5>&1
273 exec 6<&0
274 if test "$verbose" = "t"
275 then
276 exec 4>&2 3>&1
277 else
278 exec 4>/dev/null 3>/dev/null
281 test_failure=0
282 test_count=0
283 test_fixed=0
284 test_broken=0
285 test_success=0
287 test_external_has_tap=0
289 die () {
290 code=$?
291 if test -n "$GIT_EXIT_OK"
292 then
293 exit $code
294 else
295 echo >&5 "FATAL: Unexpected exit with code $code"
296 exit 1
300 GIT_EXIT_OK=
301 trap 'die' EXIT
303 # The user-facing functions are loaded from a separate file so that
304 # test_perf subshells can have them too
305 . "$TEST_DIRECTORY/test-lib-functions.sh"
307 # You are not expected to call test_ok_ and test_failure_ directly, use
308 # the test_expect_* functions instead.
310 test_ok_ () {
311 test_success=$(($test_success + 1))
312 say_color "" "ok $test_count - $@"
315 test_failure_ () {
316 test_failure=$(($test_failure + 1))
317 say_color error "not ok $test_count - $1"
318 shift
319 printf '%s\n' "$*" | sed -e 's/^/# /'
320 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
323 test_known_broken_ok_ () {
324 test_fixed=$(($test_fixed+1))
325 say_color error "ok $test_count - $@ # TODO known breakage vanished"
328 test_known_broken_failure_ () {
329 test_broken=$(($test_broken+1))
330 say_color warn "not ok $test_count - $@ # TODO known breakage"
333 test_debug () {
334 test "$debug" = "" || eval "$1"
337 match_pattern_list () {
338 arg="$1"
339 shift
340 test -z "$*" && return 1
341 for pattern_
343 case "$arg" in
344 $pattern_)
345 return 0
346 esac
347 done
348 return 1
351 match_test_selector_list () {
352 title="$1"
353 shift
354 arg="$1"
355 shift
356 test -z "$1" && return 0
358 # Both commas and whitespace are accepted as separators.
359 OLDIFS=$IFS
360 IFS=' ,'
361 set -- $1
362 IFS=$OLDIFS
364 # If the first selector is negative we include by default.
365 include=
366 case "$1" in
367 !*) include=t ;;
368 esac
370 for selector
372 orig_selector=$selector
374 positive=t
375 case "$selector" in
377 positive=
378 selector=${selector##?}
380 esac
382 test -z "$selector" && continue
384 case "$selector" in
385 *-*)
386 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
387 then
388 echo "error: $title: invalid non-numeric in range" \
389 "start: '$orig_selector'" >&2
390 exit 1
392 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
393 then
394 echo "error: $title: invalid non-numeric in range" \
395 "end: '$orig_selector'" >&2
396 exit 1
400 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
401 then
402 echo "error: $title: invalid non-numeric in test" \
403 "selector: '$orig_selector'" >&2
404 exit 1
406 esac
408 # Short cut for "obvious" cases
409 test -z "$include" && test -z "$positive" && continue
410 test -n "$include" && test -n "$positive" && continue
412 case "$selector" in
414 if test $arg -le ${selector#-}
415 then
416 include=$positive
420 if test $arg -ge ${selector%-}
421 then
422 include=$positive
425 *-*)
426 if test ${selector%%-*} -le $arg \
427 && test $arg -le ${selector#*-}
428 then
429 include=$positive
433 if test $arg -eq $selector
434 then
435 include=$positive
438 esac
439 done
441 test -n "$include"
444 maybe_teardown_verbose () {
445 test -z "$verbose_only" && return
446 exec 4>/dev/null 3>/dev/null
447 verbose=
450 last_verbose=t
451 maybe_setup_verbose () {
452 test -z "$verbose_only" && return
453 if match_pattern_list $test_count $verbose_only
454 then
455 exec 4>&2 3>&1
456 # Emit a delimiting blank line when going from
457 # non-verbose to verbose. Within verbose mode the
458 # delimiter is printed by test_expect_*. The choice
459 # of the initial $last_verbose is such that before
460 # test 1, we do not print it.
461 test -z "$last_verbose" && echo >&3 ""
462 verbose=t
463 else
464 exec 4>/dev/null 3>/dev/null
465 verbose=
467 last_verbose=$verbose
470 maybe_teardown_valgrind () {
471 test -z "$GIT_VALGRIND" && return
472 GIT_VALGRIND_ENABLED=
475 maybe_setup_valgrind () {
476 test -z "$GIT_VALGRIND" && return
477 if test -z "$valgrind_only"
478 then
479 GIT_VALGRIND_ENABLED=t
480 return
482 GIT_VALGRIND_ENABLED=
483 if match_pattern_list $test_count $valgrind_only
484 then
485 GIT_VALGRIND_ENABLED=t
489 # This is a separate function because some tests use
490 # "return" to end a test_expect_success block early
491 # (and we want to make sure we run any cleanup like
492 # "set +x").
493 test_eval_inner_ () {
494 # Do not add anything extra (including LF) after '$*'
495 eval "
496 test \"$trace\" = t && set -x
500 test_eval_ () {
501 # We run this block with stderr redirected to avoid extra cruft
502 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
503 # the shell from printing the "set +x" to turn it off (nor the saving
504 # of $? before that). But we can make sure that the output goes to
505 # /dev/null.
507 # The test itself is run with stderr put back to &4 (so either to
508 # /dev/null, or to the original stderr if --verbose was used).
510 test_eval_inner_ "$@" </dev/null >&3 2>&4
511 test_eval_ret_=$?
512 if test "$trace" = t
513 then
514 set +x
515 if test "$test_eval_ret_" != 0
516 then
517 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
520 } 2>/dev/null
521 return $test_eval_ret_
524 test_run_ () {
525 test_cleanup=:
526 expecting_failure=$2
527 setup_malloc_check
528 test_eval_ "$1"
529 eval_ret=$?
530 teardown_malloc_check
532 if test -z "$immediate" || test $eval_ret = 0 ||
533 test -n "$expecting_failure" && test "$test_cleanup" != ":"
534 then
535 setup_malloc_check
536 test_eval_ "$test_cleanup"
537 teardown_malloc_check
539 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
540 then
541 echo ""
543 return "$eval_ret"
546 test_start_ () {
547 test_count=$(($test_count+1))
548 maybe_setup_verbose
549 maybe_setup_valgrind
552 test_finish_ () {
553 echo >&3 ""
554 maybe_teardown_valgrind
555 maybe_teardown_verbose
558 test_skip () {
559 to_skip=
560 skipped_reason=
561 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
562 then
563 to_skip=t
564 skipped_reason="GIT_SKIP_TESTS"
566 if test -z "$to_skip" && test -n "$test_prereq" &&
567 ! test_have_prereq "$test_prereq"
568 then
569 to_skip=t
571 of_prereq=
572 if test "$missing_prereq" != "$test_prereq"
573 then
574 of_prereq=" of $test_prereq"
576 skipped_reason="missing $missing_prereq${of_prereq}"
578 if test -z "$to_skip" && test -n "$run_list" &&
579 ! match_test_selector_list '--run' $test_count "$run_list"
580 then
581 to_skip=t
582 skipped_reason="--run"
585 case "$to_skip" in
587 say_color skip >&3 "skipping test: $@"
588 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
589 : true
592 false
594 esac
597 # stub; perf-lib overrides it
598 test_at_end_hook_ () {
602 test_done () {
603 GIT_EXIT_OK=t
605 if test -z "$HARNESS_ACTIVE"
606 then
607 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
608 mkdir -p "$test_results_dir"
609 base=${0##*/}
610 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
612 cat >>"$test_results_path" <<-EOF
613 total $test_count
614 success $test_success
615 fixed $test_fixed
616 broken $test_broken
617 failed $test_failure
622 if test "$test_fixed" != 0
623 then
624 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
626 if test "$test_broken" != 0
627 then
628 say_color warn "# still have $test_broken known breakage(s)"
630 if test "$test_broken" != 0 || test "$test_fixed" != 0
631 then
632 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
633 msg="remaining $test_remaining test(s)"
634 else
635 test_remaining=$test_count
636 msg="$test_count test(s)"
638 case "$test_failure" in
640 # Maybe print SKIP message
641 if test -n "$skip_all" && test $test_count -gt 0
642 then
643 error "Can't use skip_all after running some tests"
645 test -z "$skip_all" || skip_all=" # SKIP $skip_all"
647 if test $test_external_has_tap -eq 0
648 then
649 if test $test_remaining -gt 0
650 then
651 say_color pass "# passed all $msg"
653 say "1..$test_count$skip_all"
656 test -d "$remove_trash" &&
657 cd "$(dirname "$remove_trash")" &&
658 rm -rf "$(basename "$remove_trash")"
660 test_at_end_hook_
662 exit 0 ;;
665 if test $test_external_has_tap -eq 0
666 then
667 say_color error "# failed $test_failure among $msg"
668 say "1..$test_count"
671 exit 1 ;;
673 esac
676 if test -n "$valgrind"
677 then
678 make_symlink () {
679 test -h "$2" &&
680 test "$1" = "$(readlink "$2")" || {
681 # be super paranoid
682 if mkdir "$2".lock
683 then
684 rm -f "$2" &&
685 ln -s "$1" "$2" &&
686 rm -r "$2".lock
687 else
688 while test -d "$2".lock
690 say "Waiting for lock on $2."
691 sleep 1
692 done
697 make_valgrind_symlink () {
698 # handle only executables, unless they are shell libraries that
699 # need to be in the exec-path.
700 test -x "$1" ||
701 test "# " = "$(head -c 2 <"$1")" ||
702 return;
704 base=$(basename "$1")
705 symlink_target=$GIT_BUILD_DIR/$base
706 # do not override scripts
707 if test -x "$symlink_target" &&
708 test ! -d "$symlink_target" &&
709 test "#!" != "$(head -c 2 < "$symlink_target")"
710 then
711 symlink_target=../valgrind.sh
713 case "$base" in
714 *.sh|*.perl)
715 symlink_target=../unprocessed-script
716 esac
717 # create the link, or replace it if it is out of date
718 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
721 # override all git executables in TEST_DIRECTORY/..
722 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
723 mkdir -p "$GIT_VALGRIND"/bin
724 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
726 make_valgrind_symlink $file
727 done
728 # special-case the mergetools loadables
729 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
730 OLDIFS=$IFS
731 IFS=:
732 for path in $PATH
734 ls "$path"/git-* 2> /dev/null |
735 while read file
737 make_valgrind_symlink "$file"
738 done
739 done
740 IFS=$OLDIFS
741 PATH=$GIT_VALGRIND/bin:$PATH
742 GIT_EXEC_PATH=$GIT_VALGRIND/bin
743 export GIT_VALGRIND
744 GIT_VALGRIND_MODE="$valgrind"
745 export GIT_VALGRIND_MODE
746 GIT_VALGRIND_ENABLED=t
747 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
748 export GIT_VALGRIND_ENABLED
749 elif test -n "$GIT_TEST_INSTALLED"
750 then
751 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
752 error "Cannot run git from $GIT_TEST_INSTALLED."
753 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
754 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
755 else # normal case, use ../bin-wrappers only unless $with_dashes:
756 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
757 if ! test -x "$git_bin_dir/git"
758 then
759 if test -z "$with_dashes"
760 then
761 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
763 with_dashes=t
765 PATH="$git_bin_dir:$PATH"
766 GIT_EXEC_PATH=$GIT_BUILD_DIR
767 if test -n "$with_dashes"
768 then
769 PATH="$GIT_BUILD_DIR:$PATH"
772 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
773 GIT_CONFIG_NOSYSTEM=1
774 GIT_ATTR_NOSYSTEM=1
775 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
777 if test -z "$GIT_TEST_CMP"
778 then
779 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
780 then
781 GIT_TEST_CMP="$DIFF -c"
782 else
783 GIT_TEST_CMP="$DIFF -u"
787 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
788 export GITPERLLIB
789 test -d "$GIT_BUILD_DIR"/templates/blt || {
790 error "You haven't built things yet, have you?"
793 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
794 then
795 echo >&2 'You need to build test-chmtime:'
796 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
797 exit 1
800 # Test repository
801 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
802 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
803 case "$TRASH_DIRECTORY" in
804 /*) ;; # absolute path is good
805 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
806 esac
807 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
808 rm -fr "$TRASH_DIRECTORY" || {
809 GIT_EXIT_OK=t
810 echo >&5 "FATAL: Cannot prepare test area"
811 exit 1
814 HOME="$TRASH_DIRECTORY"
815 GNUPGHOME="$HOME/gnupg-home-not-used"
816 export HOME GNUPGHOME
818 # run the tput tests *after* changing HOME (in case ncurses needs
819 # ~/.terminfo for $TERM)
820 test -n "${color+set}" || test "x$ORIGINAL_TERM" != "xdumb" && (
821 TERM=$ORIGINAL_TERM &&
822 export TERM &&
823 test -t 1 &&
824 tput bold >/dev/null 2>&1 &&
825 tput setaf 1 >/dev/null 2>&1 &&
826 tput sgr0 >/dev/null 2>&1
827 ) &&
828 color=t
830 if test -n "$color"
831 then
832 say_color () {
834 TERM=$ORIGINAL_TERM
835 export TERM
836 case "$1" in
837 error)
838 tput bold; tput setaf 1;; # bold red
839 skip)
840 tput setaf 4;; # blue
841 warn)
842 tput setaf 3;; # brown/yellow
843 pass)
844 tput setaf 2;; # green
845 info)
846 tput setaf 6;; # cyan
848 test -n "$quiet" && return;;
849 esac
850 shift
851 printf "%s" "$*"
852 tput sgr0
853 echo
856 else
857 say_color() {
858 test -z "$1" && test -n "$quiet" && return
859 shift
860 printf "%s\n" "$*"
864 if test -z "$TEST_NO_CREATE_REPO"
865 then
866 test_create_repo "$TRASH_DIRECTORY"
867 else
868 mkdir -p "$TRASH_DIRECTORY"
870 # Use -P to resolve symlinks in our working directory so that the cwd
871 # in subprocesses like git equals our $PWD (for pathname comparisons).
872 cd -P "$TRASH_DIRECTORY" || exit 1
874 this_test=${0##*/}
875 this_test=${this_test%%-*}
876 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
877 then
878 say_color info >&3 "skipping test $this_test altogether"
879 skip_all="skip all tests in $this_test"
880 test_done
883 # Provide an implementation of the 'yes' utility
884 yes () {
885 if test $# = 0
886 then
888 else
889 y="$*"
892 while echo "$y"
895 done
898 # Fix some commands on Windows
899 case $(uname -s) in
900 *MINGW*)
901 # Windows has its own (incompatible) sort and find
902 sort () {
903 /usr/bin/sort "$@"
905 find () {
906 /usr/bin/find "$@"
908 sum () {
909 md5sum "$@"
911 # git sees Windows-style pwd
912 pwd () {
913 builtin pwd -W
915 # no POSIX permissions
916 # backslashes in pathspec are converted to '/'
917 # exec does not inherit the PID
918 test_set_prereq MINGW
919 test_set_prereq NATIVE_CRLF
920 test_set_prereq SED_STRIPS_CR
921 test_set_prereq GREP_STRIPS_CR
922 GIT_TEST_CMP=mingw_test_cmp
924 *CYGWIN*)
925 test_set_prereq POSIXPERM
926 test_set_prereq EXECKEEPSPID
927 test_set_prereq CYGWIN
928 test_set_prereq SED_STRIPS_CR
929 test_set_prereq GREP_STRIPS_CR
932 test_set_prereq POSIXPERM
933 test_set_prereq BSLASHPSPEC
934 test_set_prereq EXECKEEPSPID
936 esac
938 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
939 test -z "$NO_PERL" && test_set_prereq PERL
940 test -z "$NO_PYTHON" && test_set_prereq PYTHON
941 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
942 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
944 # Can we rely on git's output in the C locale?
945 if test -n "$GETTEXT_POISON"
946 then
947 GIT_GETTEXT_POISON=YesPlease
948 export GIT_GETTEXT_POISON
949 test_set_prereq GETTEXT_POISON
950 else
951 test_set_prereq C_LOCALE_OUTPUT
954 # Use this instead of test_cmp to compare files that contain expected and
955 # actual output from git commands that can be translated. When running
956 # under GETTEXT_POISON this pretends that the command produced expected
957 # results.
958 test_i18ncmp () {
959 test -n "$GETTEXT_POISON" || test_cmp "$@"
962 # Use this instead of "grep expected-string actual" to see if the
963 # output from a git command that can be translated either contains an
964 # expected string, or does not contain an unwanted one. When running
965 # under GETTEXT_POISON this pretends that the command produced expected
966 # results.
967 test_i18ngrep () {
968 if test -n "$GETTEXT_POISON"
969 then
970 : # pretend success
971 elif test "x!" = "x$1"
972 then
973 shift
974 ! grep "$@"
975 else
976 grep "$@"
980 test_lazy_prereq PIPE '
981 # test whether the filesystem supports FIFOs
982 case $(uname -s) in
983 CYGWIN*)
984 false
987 rm -f testfifo && mkfifo testfifo
989 esac
992 test_lazy_prereq SYMLINKS '
993 # test whether the filesystem supports symbolic links
994 ln -s x y && test -h y
997 test_lazy_prereq FILEMODE '
998 test "$(git config --bool core.filemode)" = true
1001 test_lazy_prereq CASE_INSENSITIVE_FS '
1002 echo good >CamelCase &&
1003 echo bad >camelcase &&
1004 test "$(cat CamelCase)" != good
1007 test_lazy_prereq UTF8_NFD_TO_NFC '
1008 # check whether FS converts nfd unicode to nfc
1009 auml=$(printf "\303\244")
1010 aumlcdiar=$(printf "\141\314\210")
1011 >"$auml" &&
1012 case "$(echo *)" in
1013 "$aumlcdiar")
1014 true ;;
1016 false ;;
1017 esac
1020 test_lazy_prereq AUTOIDENT '
1021 sane_unset GIT_AUTHOR_NAME &&
1022 sane_unset GIT_AUTHOR_EMAIL &&
1023 git var GIT_AUTHOR_IDENT
1026 test_lazy_prereq EXPENSIVE '
1027 test -n "$GIT_TEST_LONG"
1030 test_lazy_prereq USR_BIN_TIME '
1031 test -x /usr/bin/time
1034 test_lazy_prereq NOT_ROOT '
1035 uid=$(id -u) &&
1036 test "$uid" != 0
1039 # On a filesystem that lacks SANITY, a file can be deleted even if
1040 # the containing directory doesn't have write permissions, or a file
1041 # can be accessed even if the containing directory doesn't have read
1042 # or execute permissions, causing our tests that validate that Git
1043 # works sensibly in such situations.
1044 test_lazy_prereq SANITY '
1045 mkdir SANETESTD.1 SANETESTD.2 &&
1047 chmod +w SANETESTD.1 SANETESTD.2 &&
1048 >SANETESTD.1/x 2>SANETESTD.2/x &&
1049 chmod -w SANETESTD.1 &&
1050 chmod -rx SANETESTD.2 ||
1051 error "bug in test sript: cannot prepare SANETESTD"
1053 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1054 status=$?
1056 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1057 rm -rf SANETESTD.1 SANETESTD.2 ||
1058 error "bug in test sript: cannot clean SANETESTD"
1059 return $status
1062 GIT_UNZIP=${GIT_UNZIP:-unzip}
1063 test_lazy_prereq UNZIP '
1064 "$GIT_UNZIP" -v
1065 test $? -ne 127